%% Panda BEVintage
% VPE_s1 input data
%%First
%% Samsung Battery Pack Parameters
% Samsung Battery 50 Ah Datasheet Block Parameters
U_s=[4.238 4.146 4.083 4.024 3.968 3.917 3.869 3.823 3.778 3.736 3.687 3.649 3.628 3.611 3.593 3.574 3.542 3.496 3.438 3.401 3.266]';
SOC_Brkpoints_s=0:0.05:1;
T_LUT_s=[-25 -10 0 10 25 40]+273.15;
SOC_Resistance_Brkpoints_s= [0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9];

R_battery_Discharging_30=[53.49 	20.28 	11.06 	9.70 	9.34 	9.45 	9.30 	9.29 	9.43; 
22.72 	9.23 	5.53 	5.06 	4.90 	4.92 	4.85 	4.84 	4.90; 
12.46 	5.67 	3.73 	3.42 	3.31 	3.41 	3.36 	3.35 	3.40;
6.59 	3.91 	2.73 	2.51 	2.46 	2.55 	2.54 	2.50 	2.60; 
3.68 	2.73 	1.94 	1.78 	1.77 	1.85 	1.86 	1.88 	1.91; 
2.47 	1.77 	1.53 	1.52 	1.40 	1.49 	1.54 	1.55 	1.57].*10^-3;

R_battery_Charging_30=[26.33 	22.68 	20.78 	19.52 	19.88 	19.41 	19.43 	19.22 	22.19;
9.74 	8.08 	7.34 	7.18 	7.40 	7.33 	7.36 	7.46 	7.57; 
5.51 	4.53 	4.10 	4.03 	4.29 	4.24 	4.25 	4.27 	4.35; 
3.31 	2.87 	2.60 	2.51 	2.71 	2.71 	2.70 	2.73 	2.80; 
2.05 	1.90 	1.68 	1.64 	1.83 	1.81 	1.82 	1.85 	1.87;
1.60 	1.57 	1.39 	1.34 	1.47 	1.48 	1.48 	1.51 	1.51].*10^-3;

% Cell dimensions and sizes
cell_thickness_s = 26.5*10^-3; %m
cell_width_s = 91*10^-3; %m
cell_length_s = 148*10^-3; %m

% Cell volume
samsung_cell_volume = cell_thickness_s*cell_width_s*cell_length_s; %m^3

% Cell mass
samsung_cell_mass = 0.875; %kg

% Volumetric heat capacity
% assumes uniform heat capacity throughout the cell
% ref: J. Electrochemical Society 158 (8) A955-A969 (2011) pA962
cell_rho_Cp = 2.04E6; %J/m3/K

%Specific Heat
samsung_Cp_heat = (cell_rho_Cp * samsung_cell_volume)/samsung_cell_mass; %J/kg/K
%cells in series/parallel
Ns_s=28;
Np_s=2;
% Pack Mass
m_s=samsung_cell_mass*Ns_s*Np_s ; %Kg
C_b_s=m_s*samsung_Cp_heat; % Before it was: C_b_s=m_s*samsung_Cp_heat;
Qe_init_s = 0; %Ampere*hours



%% Panda BEVintage
% VPE_s1 input data
%% Vehicle Body Total Load (Computed)
m_e = 842;
c_0 = 125.5;
c_1 = 7;
c_2 = 0.4380;
g = 9.81;

%% Mapped Motor
% Electrical Torque - Nominal & Maximal
w_n = 4000 /60*2*pi;
T_m_n = 28;
eta_n = 0.919 *100; %@ w_n & T_m_n
P_m_n = w_n * T_m_n;
T_m_max =66 ;
P_m_max = w_n*T_m_max*1.1;
tau_m = 0.02;
% Electrical Losses - Single Efficiency
Pl_iron = 0; %IPM
Pl_eln = 100;
Pl_copper_n = (100/eta_n-1)*P_m_n -Pl_eln -Pl_iron;
k_T = Pl_copper_n /T_m_n^2;
% Electrical Losses - Tabulated Ploss Data
motorspeed=[1000 2000 3000 3500 4000].*pi()/30; %rad/s
motortorque=[11.4 13.8 15.2 20.9 26.9]; %Nm

P_loss_data=[151.9	126.8	304.9	468.1	712.5;
223.7	223.6	350.5	701.4	801.2;
311.2	311.4	693.4	1005.9	1299.9;
434.4	351.7	556.3	1056.4	1407.6;
572.9	395.7	813.2	1204.9	1013.4]; %W

efficiency_map=[0.880	0.919	0.845	0.826	0.845;
0.905	0.922	0.902	0.862	0.892;
0.909	0.933	0.873	0.867	0.912;
0.893	0.935	0.909	0.878	0.916;
0.881	0.935	0.887	0.881	0.919].*100;

% Mechanical
J_m = .005e-3;
beta_m = 1e-5;

% Motor Air-Cooled Parameters
R_ma=0.07; %K/W ,Thermal resistance btw motor and air
C_m=12000; %J/K, Thermal Capacitance of motor
m_m=31; %Kg, Mass of the motor

% Motor Liquid-Cooled Parameters
R_mc=0.036; %K/W Thermal resistance btw motor and coolant
Kr_Ar=180; %W/K, Radiator heat transfer coefficient

%% Transmission
r_e = 0.27;
T_r = 8.67;

%% Longitudinal Driver
V_max = 120 /3.6;
K_p = 15;
K_i = 1;
K_aw = 0.1;
K_ff = 0.05;
K_g = 0.01;
tau_e = 0.03;


%% On/Off Braking Parameters

max_decel=0.8; %max deceleration achievable with hydraulic brakes

% Parametrs for on/off regenerative braking (C1 and C2 strategies)
% brake_magnitude=0.4; %regeneration level
onoff_lower_limit_rpm=200 %lower motor rpm treshold to turn off regeneration
off_torque=0; %regenerative torque when motor rpm becomes lower than the lower treshold
radps_to_rpm=60/(2*pi);
filter_time_constant=0.1; %filter time constant to relax the activation/deactivation of on/off regeneration
pedal_acc_breakpoints_input = [0 5 30 50 70 95 100]; %Accelerator pedal mapping's break points for on/off
pedal_acc_breakpoints_output = [0 0 80/45*25 80 20/45*20+80 100 100 ]; %Accelerator pedal mapping's output at the break points for on/off



%%  Battery cooling System Parameters

% Air
air_kinematic_viscosity = 1.589e-05;
Pr_air = 0.707;
k_air = 0.0263;

%water
water_density = 997.009;
water_dynamic_viscosity = 8.55e-04;
k_water = 0.613;
Pr_water = 5.83;

%box
k_box = 150; %box material thermal conductivity
l_tube = 0.059; %m
w_tube = 0.018; %m
w_fin = 0.580; %fin width
t_fin = 0.001; %fin thickness
l_fin = 0.018; %fin length
N_fin = 9; %number of fins
A_bottom = 0.35 ; %box bottom area
t_bottom = 0.002; %box bottom thickness
A_tube = 0.034; %single tube heat exchange area
N_tubes = 10; %number of tubes
R_contact = 0; %contact resistance between batteries and box

Re_threshold = 10000;

Dh = (2 * l_tube * w_tube)/(l_tube + w_tube); %hydraulic diameter
p_fin = 2 * (w_fin + t_fin); % fin primeter
Ac_fin = w_fin * t_fin; % fin cross sectional area
Re_const_a = Dh / air_kinematic_viscosity;
Nu_const_a = 0.023 * Pr_air^0.4 ;
h_const_a = k_air / Dh ;
R_conduction = t_bottom / (k_box * A_bottom);
R_cond_cont = R_contact + R_conduction ;
A_tubes_tot = A_tube * N_tubes ;
pkfAc = p_fin * k_box * Ac_fin ; %for equation: Rf,N=1/(N_fin * sqrt(hpkfAc) * tanh(mLf))
p_kfAc = p_fin / (k_box * Ac_fin);

Nominal_Capacity_s=50;
I_charging= -45; % Amperes
air_speed = 3; %m/s


% Mass of Coolant
m_f_total=23.5; %Kg including motor coupling
m_f_m=18.5; %Kg only motor water cooling
% Specific heat of Coolant
cp_f= 3403; %J/Kg.K
% Thermal Resistance between battery and coolant.
R_bc=0.033; %K/W
%Thermal Capacitance of coolant
C_c=m_f_total*cp_f;
C_c_1=m_f_m*cp_f;


V_b_initial_s=U_s(1)*Ns_s;

%% Vehicle Body Total Load (Computed)
m_e = 842;
c_0 = 145; %Computed 116.07;
c_1 = 5; %Computed 0
c_2 = 0.4380;
g = 9.81;

%% Mapped Motor (Sitem)
% Electrical Torque - Nominal & Maximal
w_n = 4000 /60*2*pi;
T_m_n = 30;
eta_n = 0.91 *100; %@ w_n & T_m_n
P_m_n = w_n * T_m_n
T_m_max = 50;
P_m_max = w_n*T_m_max*1.1
tau_m = 0.02;
% Electrical Losses - Single Efficiency
Pl_iron = 0; %IPM
Pl_eln = 100;
Pl_copper_n = (1-eta_n/100)*P_m_n -Pl_eln -Pl_iron
k_T = Pl_copper_n /T_m_n^2
% Mechanical
J_m = .005e-3;
beta_m = 1e-5;

%% Transmission
r_e = 0.29;
T_r = 8.67;

%% Longitudinal Driver
V_max = 120 /3.6;
K_p = 15;
K_i = 1;
K_aw = 0.1;
K_ff = 0.05;
K_g = 0.01;
tau_e = 0.03;

%% Battery


% Cell volume
samsung_cell_volume = cell_thickness_s*cell_width_s*cell_length_s; %m^3
cell_volume = samsung_cell_volume ;
% Cell mass
samsung_cell_mass = 0.875; %kg

% Volumetric heat capacity
% assumes uniform heat capacity throughout the cell
% ref: J. Electrochemical Society 158 (8) A955-A969 (2011) pA962
cell_rho_Cp = 2.04E6; %J/m3/K

V_b_initial=U_s(1)*28;

%Specific Heat
samsung_Cp_heat = (cell_rho_Cp * samsung_cell_volume)/samsung_cell_mass; %J/kg/K


Nominal_Capacity=50;
Initial_Capacity=V_b_initial_s;

%%UKF
numCells = 1;
% load('Kokam_LUT_3RC')%
results.T5C  = load('Batterypara1.mat');
results.T20C = load('Batterypara2.mat');
results.T40C = load('Batterypara3.mat');
SOC_LUT = 0;0.05;1;
for idx = 1:numCells
%% Lookup Table Breakpoints

Battery(idx).SOC_LUT = SOC_LUT;
Battery(idx).Temperature_LUT = [5 20 40] + 273.15;

%% Em Branch Properties (OCV, Capacity)

% Battery capacity
Battery(idx).Capacity_LUT = [31 31 31]; %Ampere*hours

%% Em Branch Properties (OCV, Capacity)

% Em open-circuit voltage vs SOC rows and T columns
Battery(idx).Em_LUT = [ results.T5C.Em ...
                        results.T20C.Em ...
                        results.T40C.Em]; %Volts

%% Terminal Resistance Properties

% R0 resistance vs SOC rows and T columns
Battery(idx).R0_LUT = [ results.T5C.R0 ...
                        results.T20C.R0 ...
                        results.T40C.R0]; %Ohms

%% RC Branch 1 Properties

% R1 Resistance vs SOC rows and T columns
Battery(idx).R1_LUT = [ results.T5C.R1 ...
                        results.T20C.R1 ...
                        results.T40C.R1]; %Ohms

% R2 Resistance vs SOC rows and T columns
Battery(idx).R2_LUT = [ results.T5C.R2 ...
                        results.T20C.R2 ...
                        results.T40C.R2]; %Ohms

% R3 Resistance vs SOC rows and T columns
Battery(idx).R3_LUT = [ results.T5C.R3 ...
                        results.T20C.R3 ...
                        results.T40C.R3]; %Ohms

% C1 Capacitance vs SOC rows and T columns
Battery(idx).t1_LUT = [ results.T5C.tau1 ...
                        results.T20C.tau1 ...
                        results.T40C.tau1]; %Farads

% C2 Capacitance vs SOC rows and T columns
Battery(idx).t2_LUT = [ results.T5C.tau2 ...
                        results.T20C.tau2 ...
                        results.T40C.tau2]; %Farads

% C3 Capacitance vs SOC rows and T columns
Battery(idx).t3_LUT = [ results.T5C.tau3 ...
                        results.T20C.tau3 ...
                        results.T40C.tau3]; %Farads

%% 
% Cell mass
Battery(idx).cell_mass = 0.84; %kg

% Volumetric heat capacity
% assumes uniform heat capacity throughout the cell
% ref: J. Electrochemical Society 158 (8) A955-A969 (2011) pA962
Battery(idx).cell_rho_Cp = 2.04E6; %J/m3/K

% Specific Heat
Battery(idx).cell_Cp_heat = Battery(idx).cell_rho_Cp * cell_volume / Battery(idx).cell_mass; %J/kg/K
%% Initial Conditions

% Ambient Temperature
Battery(idx).T_init = 20 + 273.15; %K

% Initial charge deficit
Battery(idx).Qe_init = 0.5 * mean(Battery(idx).Capacity_LUT); %Ampere*hours
Battery(idx).SOC0 = (Battery(idx).Capacity_LUT(2) - Battery(idx).Qe_init)/...
                                  Battery(idx).Capacity_LUT(2);

end
%%


% Convective heat transfer coefficient
% For natural convection this number should be in the range of 5 to 25
h_conv = 5; %W/m^2/K Cell-to-cell
h_conv_end = 10; %W/m^2/K End cells to ambient

Ts=1

%%

load('SumsungBattery.mat')





